diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/RELEASE_NOTES ns-3.31/RELEASE_NOTES
--- ns-3.30.1/RELEASE_NOTES	2019-09-18 10:41:27.000000000 -0700
+++ ns-3.31/RELEASE_NOTES	2020-06-27 17:40:01.000000000 -0700
@@ -2496,19 +2576,19 @@
      from YansErrorRateModel for OFDM modes (802.11a/g).  The default
      YansWifiPhyHelper has been changed to use this model.
 
-   - A new NS-2 mobility trace reader supports BonnMotion, SUMO, TraNS, 
+   - A new NS-2 mobility trace reader supports BonnMotion, SUMO, TraNS,
      etc. traces.
 
    - An energy model for nodes and devices, including an energy source
      model and device energy models allowing energy-aware devices
-     to notify the energy source about energy consumption.  
+     to notify the energy source about energy consumption.
 
    - Rocketfuel topology dataset support for existing topology reader
-     Rocketfuel project: 
+     Rocketfuel project:
      http://www.cs.washington.edu/research/networking/rocketfuel/
 
-   - Underwater Acoustic Network (UAN) model, split in to three parts, the 
-     channel, PHY, and MAC models to enable researchers to model a variety 
+   - Underwater Acoustic Network (UAN) model, split in to three parts, the
+     channel, PHY, and MAC models to enable researchers to model a variety
      of underwater network scenarios.
 
    - the Spectrum framework, which provides support for spectrum-aware
@@ -2516,18 +2596,18 @@
      allows the mathematical representation of frequency dependent
      phenomena. Some example channel, propagation and device
      implementations that make use of this framework are also
-     included.  
+     included.
 
 Bugs fixed
 ----------
-The following lists many of the bugs fixed or small feature additions 
+The following lists many of the bugs fixed or small feature additions
 since ns-3.8, in many cases referencing the Bugzilla bug number
 
    - IPv4 global routing code; stub networks were assumed to be /24
      and added as /24 networks even if the mask is actually different
    - OLSR was generating messages on non-OLSR interfaces
    - ICMPv4 objects not properly registered; affected serialization code
-   - bug 231 - SocketAddressTag needs to be removed from a packet before 
+   - bug 231 - SocketAddressTag needs to be removed from a packet before
                forwarding the packet to the user
    - bug 385 - Add a generic "sequence number" class
    - bug 473 - [PATCH] Alternative ns-2 trace reader
@@ -2541,13 +2621,13 @@
    - bug 828 - PacketSocket::Close does not unregister protocol handler
    - bug 842 - ns-3-dev crashes using block acks
    - bug 843 - Most wifi examples change BeaconInterval to unrealistic values
-   - bug 844 - YansWifiPhy::GetPowerDbm off-by-one problem when calculating Tx 
+   - bug 844 - YansWifiPhy::GetPowerDbm off-by-one problem when calculating Tx
                power
    - bug 846 - packet.cc triggers deprecated warning
    - bug 853 - Rates for Wi-Fi control responses are incorrectly selected
    - bug 854 - Support DROP_QUEUE reason-code in Ipv4FlowProbe
    - bug 858 - support MSG_PEEK in IPv4/IPv6 raw socket
-   - bug 861 - Forwarding drops (due to no route found) were not being logged 
+   - bug 861 - Forwarding drops (due to no route found) were not being logged
                in IPv4 or IPv6 ascii traces
    - bug 869 - suggested test framework enhancements
    - bug 871 - naming for WifiPhyStandard
@@ -2570,18 +2650,18 @@
    - bug 918 - samples/main-packet-header.cc is broken
    - bug 919 - minstrel does not pass valgrind tests
    - bug 921 - Inconsistent declaration of class/struct Object in object.h
-   - bug 922 - Inconsistent declaration of class/struct in 
+   - bug 922 - Inconsistent declaration of class/struct in
                wifi-remote-station-manager.h
    - bug 923 - Inconsistent declaration of class/struct in mac-low.h
-   - bug 924 - Inconsistent declaration of class/struct in <xxx>-wifi-managers 
+   - bug 924 - Inconsistent declaration of class/struct in <xxx>-wifi-managers
    - bug 925 - Various IPv6 cc files trigger deprecated warning
-   - bug 926 - olsr handling of multicast packets 
+   - bug 926 - olsr handling of multicast packets
    - bug 927 - SimpleOfdmWimaxChannel RxPower computation
-   - bug 930 - examples/topology-read/topology-example-sim.cc uses variable 
+   - bug 930 - examples/topology-read/topology-example-sim.cc uses variable
                length array
    - bug 931 - Abnormal exit reports SIGSEGV on failure
    - bug 932 - Support IP_HDRINCL option for Ipv4RawSocket
-   - bug 933 - Flushing ostream and files on abnormal program exit 
+   - bug 933 - Flushing ostream and files on abnormal program exit
                (ASSERT, ABORT and FATAL_ERROR)
    - bug 936 - Waf build error for python bindings on "AccessClass"
    - bug 937 - bugs in ns-3 wimax
@@ -2589,26 +2669,26 @@
    - bug 940 - AODV fails to set up a correct path
    - bug 941 - Wifi Dcf attributes not reachable through configuration namespace
    - bug 943 - Add a SO_BROADCAST socket option
-   - bug 944 - change default ErrorRateModel from YansErrorRateModel to 
+   - bug 944 - change default ErrorRateModel from YansErrorRateModel to
                NistErrorRateModel
    - bug 946 - Rocketfuel topology dataset support for topology reader
-   - bug 949 - Node::NonPromiscReceiveFromDevice reports a meaningless 
-               destination address to user callbacks 
-   - bug 950 - PointToPointNetDevice says promisc support is not implemented 
+   - bug 949 - Node::NonPromiscReceiveFromDevice reports a meaningless
+               destination address to user callbacks
+   - bug 950 - PointToPointNetDevice says promisc support is not implemented
                but it is
    - bug 955 - Install NSC for NS3 in a Itanium Architecture (ia64) with Linux 2.6.16.6
    - bug 956 - Bindings failure in core (traced-value) with older gcc
-   - bug 958 - WiFi uses wrong default values for MTU, FragmentationThreshold 
+   - bug 958 - WiFi uses wrong default values for MTU, FragmentationThreshold
                and RtsCtsThreshold
    - bug 959 - Simulation never finishes when using RealtimeSimulatorImpl
    - bug 960 - V4Ping does not generate checksum
-   - bug 961 - Problem with MPI activation 
+   - bug 961 - Problem with MPI activation
    - bug 964 - AODV does not work with host addressed interfaces
    - bug 965 - Problem building /src/core/callback.cc
-   - bug 966 - AODV originates new RREQ on each packet, when doesn't have 
+   - bug 966 - AODV originates new RREQ on each packet, when doesn't have
                valid route
    - bug 969 - No SocketList is present in UdpL4Protocol class
-   - bug 971 - fix AODV header Print functions 
+   - bug 971 - fix AODV header Print functions
    - bug 972 - [flow monitor] assertion fails in pv4-flow-probe.cc
 
 Known issues
@@ -2636,32 +2716,32 @@
 
 New user-visible features
 -------------------------
-  a) WiMAX net device: Allow to simulated IEEE 802.16 point to multi-point based networks 
+  a) WiMAX net device: Allow to simulated IEEE 802.16 point to multi-point based networks
 
-  b) Distributed simulation for point-to-point networks using the Message 
+  b) Distributed simulation for point-to-point networks using the Message
      Passing Interface (MPI) standard.
-    
-  c) Matrix propagation loss model uses a two-dimensional matrix of path loss indexed 
+
+  c) Matrix propagation loss model uses a two-dimensional matrix of path loss indexed
      by source and destination nodes.
 
-  d) Topology read system: Allows quick and easy creation of large topologies by reading 
+  d) Topology read system: Allows quick and easy creation of large topologies by reading
      Inet or Orbis files
 
-  e) Gauss-Markov mobility model: Adds 3-d adaptation of Gauss-Markov mobility model which 
+  e) Gauss-Markov mobility model: Adds 3-d adaptation of Gauss-Markov mobility model which
      has both memory and variability
 
-  f) Steady-state random waypoint mobility model: Based on random waypoint mobility (RWM) model for case when 
-     speed, pause and position are uniformly distributed random variables. However, initial values of these 
+  f) Steady-state random waypoint mobility model: Based on random waypoint mobility (RWM) model for case when
+     speed, pause and position are uniformly distributed random variables. However, initial values of these
      parameters are not from uniform distribution but from stationary distribution of RWM model.
 
-  g) Two-ray ground propagation loss model: Calculates the crossover distance under which Friis is used. 
-     The antenna height is set to the nodes z coordinate, but can be added to using the model parameter 
+  g) Two-ray ground propagation loss model: Calculates the crossover distance under which Friis is used.
+     The antenna height is set to the nodes z coordinate, but can be added to using the model parameter
      SetHeightAboveZ, which will affect ALL stations
 
 
 API changes from ns-3.7
 -----------------------
-API changes for this release are documented in the file CHANGES.html. 
+API changes for this release are documented in the file CHANGES.html.
 
 Bugs fixed
 ----------
@@ -2683,7 +2763,7 @@
    - bug 777 - AODV ignores specified outgoing interface in RouteOutput()
    - bug 778 - OLSR ignores specified outgoing interface in RouteOutput()
    - bug 787 - Addition of Two Ray Ground model to propagation loss model and tests
-   - bug 788 - OLSR_NEIGH_HOLD_TIME should be 3 times OLSR_REFRESH_INTERVAL 
+   - bug 788 - OLSR_NEIGH_HOLD_TIME should be 3 times OLSR_REFRESH_INTERVAL
    - bug 789 - [PATCH] Globalrouting externalroutes to use the new GetRootExitDirections()
    - bug 794 - Ipv4Mask constructor for "/yy"-notation is wrong
    - bug 796 - TCP bug in ns-3-dev branch : Crash detected during retesting of Chord on ns-3-dev branch
@@ -2723,9 +2803,9 @@
    - bug 850 - Ipv4GlobalRouting::LookupGlobal bug
    - bug 855 - waf dies badly when switching from debug to optimized build or vice versa
    - bug 856 - initialize vbl
-   - bug 857 - Link-Local Multicast handle in Ipv4 Output processing 
+   - bug 857 - Link-Local Multicast handle in Ipv4 Output processing
    - bug 859 - Output interface estimation for the source address bound socket in IPv4 Raw socket
-   - bug 860 - waf sometimes dies while executing ns3header or gen_ns3_module_header tasks in case of 
+   - bug 860 - waf sometimes dies while executing ns3header or gen_ns3_module_header tasks in case of
                parallel jobs
    - bug 862 - NotifyInterfaceUp() Adds network route even when netmask is /32
    - bug 863 - Wrong Scalar arithmetic
@@ -2741,7 +2821,7 @@
    - bug 880 - Node sending a packet to itself via 127.0.0.1 aborts
    - bug 885 - Error in Ascii tracing in Python examples
    - bug 888 - Writing ascii trace to additional tests fails
-   - bug 891 - WiMAX device helper does not include propagation loss model by default 
+   - bug 891 - WiMAX device helper does not include propagation loss model by default
    - bug 894 - ./waf --run error message upon segfault
    - bug 895 - SimpleOfdmWimaxPhy SNR computation
    - bug 899 - EmuNetDevice::SetPromiscReceiveCallback not implemented
@@ -2783,11 +2863,11 @@
 
   a) Ad hoc On-Demand Distance Vector (AODV) routing model (RFC 3561)
 
-  b) IPv6 extensions support to add IPv6 extensions and options.  Two 
+  b) IPv6 extensions support to add IPv6 extensions and options.  Two
      examples (fragmentation and loose routing) are available.
 
-  c) NetAnim interface: Provides an interface to the Qt-based NetAnim 
-     animator, which supports static, point-to-point topology-based 
+  c) NetAnim interface: Provides an interface to the Qt-based NetAnim
+     animator, which supports static, point-to-point topology-based
      packet animations.
 
   d) New topology helpers have been introduced
@@ -2796,40 +2876,40 @@
      - PointToPointStarHelper
      - CsmaStarHelper
 
-  e) Equal-cost multipath for global routing: Enables quagga's equal 
+  e) Equal-cost multipath for global routing: Enables quagga's equal
      cost multipath for Ipv4GlobalRouting, and adds an attribute that
-     can enable it with random packet distribution policy across 
+     can enable it with random packet distribution policy across
      equal cost routes.
 
   f) Binding sockets to devices:  A method analogous to a SO_BINDTODEVICE
      socket option has been introduced to class Socket
 
-  g) Object::DoStart: Users who need to complete their object setup at 
-     the start of a simulation can override this virtual method, perform their 
+  g) Object::DoStart: Users who need to complete their object setup at
+     the start of a simulation can override this virtual method, perform their
      adhoc setup, and then, must chain up to their parent.
 
-  h) Ipv4::IsDestinationAddress method added to support checks of whether a 
-     destination address should be accepted as one of the host's own 
-     addresses.  
+  h) Ipv4::IsDestinationAddress method added to support checks of whether a
+     destination address should be accepted as one of the host's own
+     addresses.
 
-  i) UniformDiscPositionAllocator added; distributes uniformly the nodes 
-     within a disc of given radius. 
+  i) UniformDiscPositionAllocator added; distributes uniformly the nodes
+     within a disc of given radius.
 
-  j) ChannelNumber attribute added to YansWifiPhy. Now it is possible to 
+  j) ChannelNumber attribute added to YansWifiPhy. Now it is possible to
      setup wifi channel using WifiPhyHelper::Set() method.
 
-  k) WaypointMobilityModel provides a method to add mobility as a set of 
+  k) WaypointMobilityModel provides a method to add mobility as a set of
      (time, position) pairs
 
-  l) 802.11p WiFi standards 
-  
+  l) 802.11p WiFi standards
+
   m) UDP Client/Server application
 
   n) Support transactions in the SQLite output interface, making it usable for larger amounts of data
 
 API changes from ns-3.6
 -----------------------
-API changes for this release are documented in the file CHANGES.html. 
+API changes for this release are documented in the file CHANGES.html.
 
 Bugs fixed
 ----------
@@ -2838,14 +2918,14 @@
    - bug 752: Object::DoStart is not executed for objects created at t > 0
    - bug 767:  Incorrect modulation for 802.11a modes
    - bug 725: wifi fragmentation and RTS cannot be used at the same time
-   - bug 782: CreateTap () requires IP address in modes other than 
+   - bug 782: CreateTap () requires IP address in modes other than
      CONFIGURE_LOCAL.
    - bug 769: Queue::GetTotalReceived{Bytes,Packets}() broken
    - bug 738 ReceiveErrorModel called too late
    - Fix NSC improper response to FIN
    - Fixed bug in serialization of PbbAddressBlock.
-   - Fix bug 780 (problem in RoutingTableComputation with asymmetric links), 
-     while adding debugging methods to OLSR.  
+   - Fix bug 780 (problem in RoutingTableComputation with asymmetric links),
+     while adding debugging methods to OLSR.
    - bug 759: Ipv6 uses wrong outgoing interface.
    - bug 770: IPv6 size calculation for unknown options is wrong.
    - bug 771: Radvd does not set ttl value.
@@ -2854,21 +2934,21 @@
    - Drop CSMA packets with CRC errors, rescan, dox tweaks
    - Add FCS capability to CSMA
    - Mesh:Dot11s: fixed airtime metric
-   - Get emu working again:  Add Dix/Llc option, add and use contextual 
+   - Get emu working again:  Add Dix/Llc option, add and use contextual
      realtime schedule ops, don't refcount realtime simulator impl
    - bug 695 - DcfManager::UpdateBackoff () uses slow HighPrecision::Div()
    - bug 674 - EIFS is not handled correctly in DcfManager::GetAccessGrantStart
-   - bug 739 -  OLSR: Strange HTime value in HELLO messages 
+   - bug 739 -  OLSR: Strange HTime value in HELLO messages
    - bug 746 -  UDP source address is not set to bound address
    - bug 735 Update Olsr for local delivery
    - bug 740 OLSR MprCompute () works wrong: fixed
    - bug 729 Enable IPv6 over PPP.
    - bug 645: fixes for opening stats file with OMNeT++
-   - bug 689: default energy detection and CCA thresholds are changed to be 
+   - bug 689: default energy detection and CCA thresholds are changed to be
      more realistic.
    - bug 733: OLSR MPR Computation give incorrect result
    - Mesh: HWMP: fixed proactive routes
-   - Mesh: fixed FLAME PATH_UPDATE procedure, fixed mesh.cc 
+   - Mesh: fixed FLAME PATH_UPDATE procedure, fixed mesh.cc
 
 Known issues
 ------------
@@ -2902,16 +2982,16 @@
 -------------------------
 
   a) 802.11 models:
-     - Add an implementation of the minstrel rate control algorithm 
+     - Add an implementation of the minstrel rate control algorithm
        (Duy Nguyen for gsoc)
-     - AthstatsHelper: enables the wifi device to produce periodic 
+     - AthstatsHelper: enables the wifi device to produce periodic
        reports similar to the ones generated by madwifi's
        athstats tool (Nicola Baldo)
-     - 10MHz and 5MHz channel width supported by 802.11a model 
+     - 10MHz and 5MHz channel width supported by 802.11a model
        (Ramon Bauza and Kirill Andreev)
-     - Channel switching support. YansWifiPhy can now switch among 
+     - Channel switching support. YansWifiPhy can now switch among
        different channels (Ramon Bauza and Pavel Boyko)
-  
+
   b) IPv6 models:
     - IPv6 interface;
     - IPv6 layer;
@@ -2930,7 +3010,7 @@
     - IEEE 802.11s (Draft 3.0) model including Peering Management Protocol and HWMP.
     - Forwarding Layer for Meshing (FLAME) protocol.
 
-  d) Nix-vector routing:  
+  d) Nix-vector routing:
     - Ipv4NixVectorHelper
     - Examples (nix-simple, nms-p2p-nix)
 
@@ -2945,7 +3025,7 @@
 
 API changes from ns-3.5
 -----------------------
-API changes for this release are documented in the file CHANGES.html. 
+API changes for this release are documented in the file CHANGES.html.
 
 Known issues
 ------------
@@ -2992,7 +3072,7 @@
   d) UdpEcho: allows setting the payload of echo packets
   e) Ipv4/Ipv4RoutingProtocol: allow fine-grained control over
      routing policy and arbitrary composition of routing protocols
- 
+
 API changes from ns-3.4
 -----------------------
 API changes for this release are documented in the file CHANGES.html.  The
@@ -3010,7 +3090,7 @@
 ---------------
 Our next release, which is expected to happen in 2 to 4 months from now, will
 feature the merging of some of our projects currently in development including
-fuller IPv6 support, some smaller features such as a new Global ARP 
+fuller IPv6 support, some smaller features such as a new Global ARP
 package, and possibly a new Testing and Validation suite.
 
 Release 3.4
@@ -3066,7 +3146,7 @@
   - optimized builds on Ubuntu 8.10 alpha 5 x86 gcc4.3.2
   - MinGW
 
-The IPv4 API defined in src/node/ipv4.h is expected to undergo major changes 
+The IPv4 API defined in src/node/ipv4.h is expected to undergo major changes
 in preparation of the merge of the IPv6 API and implementation.
 
 Future releases
@@ -3104,7 +3184,7 @@
      scenarios.  See src/devices/emu and examples/emu-udp-echo.cc for details.
 
   b) ICMP Support
-     Support for several ICMP messages has been added to ns-3.  See 
+     Support for several ICMP messages has been added to ns-3.  See
      src/internet-stack/icmpv4.h for details.
 
   c) IPv6 Address Support
@@ -3116,8 +3196,8 @@
   e) Star topologies can be created from the topology helper functions
 
   f) The global routing code has been made dynamic (not just limited to
-     (pre-simulation computation) and supports stub network interfaces and 
-     bridge net devices 
+     (pre-simulation computation) and supports stub network interfaces and
+     bridge net devices
 
   g) A MatchContainer has been added to the configuration subsystem
 
@@ -3134,7 +3214,7 @@
   - optimized builds on Ubuntu 8.10 alpha 5 x86 gcc4.3.2
   - MinGW
 
-The IPv4 API defined in src/node/ipv4.h is expected to undergo major changes 
+The IPv4 API defined in src/node/ipv4.h is expected to undergo major changes
 in preparation of the merge of the IPv6 API and implementation.
 
 Future releases
@@ -3172,7 +3252,7 @@
     this new mode of operation. (contributed by Gustavo Carneiro)
 
   b) Python bindings
-    It is now possible to write simulation scripts in python using our 
+    It is now possible to write simulation scripts in python using our
     python bindings (contributed by Gustavo Carneiro).
 
   c) Real-time simulator
@@ -3180,14 +3260,14 @@
     wall-clock time (contributed by Craig Dowell).
 
   d) Network Simulation Cradle
-    It is now possible to use the Network Simulation Cradle 
-    (http://www.wand.net.nz/~stj2/nsc/) in ns-3 and run simulations 
+    It is now possible to use the Network Simulation Cradle
+    (http://www.wand.net.nz/~stj2/nsc/) in ns-3 and run simulations
     using various versions of kernel TCP network stacks. (contributed
     by Florian Westphal as part of his Google Summer of Code work)
 
   e) A statistics framework
     Joseph Kopena contributed a statistics framework which can be used
-    keep track of simulation data in persistent storage across multiple 
+    keep track of simulation data in persistent storage across multiple
     runs (database and ascii file backends are available).
     More information on the wiki:
     http://www.nsnam.org/wiki/Statistical_Framework_for_Network_Simulation
@@ -3205,13 +3285,13 @@
   - optimized builds on Ubuntu 8.10 alpha 5 x86 gcc4.3.2
   - MinGW
 
-The IPv4 API defined in src/node/ipv4.h is expected to undergo major changes 
+The IPv4 API defined in src/node/ipv4.h is expected to undergo major changes
 in preparation of the merge of the IPv6 API and implementation.
 
 Future releases
 ---------------
 Our next release, which is expected to happen in 2 to 4 months from now, will
-feature the merging of some of our projects currently in development: IPv6, 
+feature the merging of some of our projects currently in development: IPv6,
 emulation, and synchronous posix sockets.
 
 Release 3.1 (2008/06/30)
@@ -3223,26 +3303,26 @@
 This release is immediately available from:
 http://www.nsnam.org/release/ns-3.1.tar.bz2
 
-We dedicate this initial ns-3 release to our late contributor and friend, 
+We dedicate this initial ns-3 release to our late contributor and friend,
 Federico Maguolo.
 
 What is ns-3 ?
 --------------
 
 ns-3 is a new discrete-event network simulator designed for supporting network
-research and education. ns-3 features a solid, well documented C++ core and 
-models for TCP/IP (IPv4), several link types including WiFi, and mobility 
+research and education. ns-3 features a solid, well documented C++ core and
+models for TCP/IP (IPv4), several link types including WiFi, and mobility
 models.
 
-ns-3 is an open source project released under the GNU GPLv2 license which 
-allows anyone to use ns-3 without having to pay any license fee or royalties. 
-ns-3 is actively seeking new contributors to extend the range of supported 
+ns-3 is an open source project released under the GNU GPLv2 license which
+allows anyone to use ns-3 without having to pay any license fee or royalties.
+ns-3 is actively seeking new contributors to extend the range of supported
 models and/or to maintain existing models.
 
 Where to get more information about ns-3
 ----------------------------------------
 
-All the ns-3 documentation, is accessible from the ns-3 website: 
+All the ns-3 documentation, is accessible from the ns-3 website:
 http://www.nsnam.org
 
 Including, tutorials:
@@ -3265,15 +3345,15 @@
   - optimized builds on gcc 3.4.4 and 3.4.5
   - optimized builds on linux x86 gcc 4.0.x
 
-The IPv4 API defined in src/node/ipv4.h is expected to undergo major changes 
+The IPv4 API defined in src/node/ipv4.h is expected to undergo major changes
 in preparation of the merge of the IPv6 API and implementation.
 
 Future releases
 ---------------
 
 Our next release, which is expected to happen in 2 to 4 months from now, will
-feature the merging of some of our projects currently in development: python 
-scripting, IPv6, emulation, a statistics framework and synchronous posix 
+feature the merging of some of our projects currently in development: python
+scripting, IPv6, emulation, a statistics framework and synchronous posix
 sockets.
 
 Release 3.0.13 (2008/06/02)
@@ -3286,21 +3366,21 @@
 - ARP cache now supports per-entry pending queues
 - lots of bugfixes and implementation and API cleanups
 
-Warning: among API changes in this release, Application::Start and 
+Warning: among API changes in this release, Application::Start and
 Application::Stop now interprets the time argument as a relative
 instead of absolute simulation time, to align with how Simulator::Schedule
-behaves.  Any code that calls these APIs in the middle of the simulation 
-will need to be adapted.  
+behaves.  Any code that calls these APIs in the middle of the simulation
+will need to be adapted.
 
-The API of Simulator::StopAt (time) has also changed.  Now it is 
-called Simulator::Stop (time), and takes a relative time, instead of 
+The API of Simulator::StopAt (time) has also changed.  Now it is
+called Simulator::Stop (time), and takes a relative time, instead of
 absolute.
 
 Release 3.0.12 (2008/04/07)
 ===========================
     - Add Attribute support to the TypeId metadata system and add
 attribute support to all in-tree models
-    - Add a mid-level helper API to build simulation topologies 
+    - Add a mid-level helper API to build simulation topologies
 and perform simple ascii and pcap link-level tracing.
     - Large amount of structural changes to accommodate the needs
 of the upcoming python bindings
@@ -3311,10 +3391,10 @@
 
 Release 3.0.11 (2008/02/15)
 ===========================
-    - Initial port of GTNetS TCP implementation (initial version 
-that does not support multitasking or delayed acknowledgments yet, 
+    - Initial port of GTNetS TCP implementation (initial version
+that does not support multitasking or delayed acknowledgments yet,
 but supports a reliable stream service)
-    - Changes to the ns-3 object model to create a TypeId-based 
+    - Changes to the ns-3 object model to create a TypeId-based
 metadata system
     - lots of bug fixes throughout the system
     - tutorial updates
@@ -3330,11 +3410,11 @@
    - A 802.11 model ported from Yans. This model supports:
        * a rather extensive PHY model
        * log-distance and friis propagation model
-       * a simple set of rate control algorithms (ARF, Ideal, 
+       * a simple set of rate control algorithms (ARF, Ideal,
          AARF, constant-rate)
        * adhoc and infrastructure mode (beacon+assoc)
    - Use smart pointer for Packet in the APIs
-   - A new contrib directory with helper classes: 
+   - A new contrib directory with helper classes:
      EventGarbageCollector, Gnuplot
    - Tracing support for Applications
    - many bugs fixed
@@ -3349,7 +3429,7 @@
   - OLSR routing protocol
   - A timer class
   - Additional mobility models (random waypoint, random 2D walk)
-  - A mobility visualization tool 
+  - A mobility visualization tool
 
 Release 3.0.6 (2007/09/15)
 ==========================
@@ -3357,7 +3437,7 @@
   - Logging overhaul (NS_LOG macros)
   - Refactoring of tracing subsystem
   - Tutorial document started
- 
+
 Release 3.0.5 (2007/08/15)
 ==========================
 
@@ -3366,14 +3446,14 @@
   - Generalized, polymorphic Address class
   - Add CSMA NetDevice model (from Emmanuelle Laprise)
   - Modularize IPv4 routing support (from Gustavo Carneiro)
-  - Add mobility framework and basic mobility models 
-  - Global unicast centralized routing 
+  - Add mobility framework and basic mobility models
+  - Global unicast centralized routing
 
 Release 3.0.4 (2007/07/15)
 ==========================
 
   - Enable waf as the default build system.
-  - Per-packet metadata:  a system to track which headers and trailers 
+  - Per-packet metadata:  a system to track which headers and trailers
     are added to a packet
   - Simplifications to point-to-point devices and channel
 
@@ -3384,9 +3464,9 @@
     with the "waf" tool. See doc/build-waf.txt.
   - Add support for variable time precision: it is now possible
     to run a simulation with an accuracy which is higher or lower
-    than a nanosecond: seconds, milliseconds, microseconds, 
+    than a nanosecond: seconds, milliseconds, microseconds,
     femtoseconds and picoseconds are supported.
-  - Optimize and rework the COM framework, solidify the component 
+  - Optimize and rework the COM framework, solidify the component
     manager
   - Many small API cleanups
 
